//
//  View.swift
//  Pearl
//
//  Created by Mark Meretzky on 10/8/14.
//  Copyright (c) 2014 Mark Meretzky. All rights reserved.
//

import UIKit

class View: UIView {
	let pearls: [Pearl] = [Pearl]();       //Create an empty array of Pearls.
	var touchPoint: CGPoint = CGPointZero; //the point where the finger touches

	required init(coder aDecoder: NSCoder) {
		for var i = 0; i < 5; ++i {
			pearls.append(Pearl());	//Create a Pearl and append it to the array.
		}
		super.init(coder: aDecoder);
		backgroundColor = UIColor.blackColor();
	}

	override func touchesBegan(touches: NSSet, withEvent event: UIEvent) {
		let touch: UITouch = touches.anyObject() as UITouch;
		touchPoint = touch.locationInView(self);
	}

	override func touchesMoved(touches: NSSet, withEvent event: UIEvent) {
		let touch: UITouch = touches.anyObject() as UITouch;
		touchPoint = touch.locationInView(self);
	}

	//Called when the width or height of this View changes.

	override func layoutSubviews() {
		touchPoint = center;
	}

	// Only override drawRect: if you perform custom drawing.
	// An empty implementation adversely affects performance during animation.

	override func drawRect(rect: CGRect)
	{
		// Drawing code

		//The first pearl is pulled towards the touch point.
		//Each remaining pearl is pulled towards the one in front of it.
		pearls[0].pullTowards(touchPoint);

		for var i = 1; i < pearls.count; ++i {
			let pearl: Pearl = pearls[i];
			let previousPearl = pearls[i - 1];
			pearl.pullTowards(previousPearl.location);
		}
	}

}
